//=============================================================================
// ANNAAugDefense.
//=============================================================================
class ANNAAugDefense extends AugDefense;

state Active
{
    function Timer()
    {
        local DeusExProjectile minproj;
        local float mindist, energyDrain;
        local _ANNAPlayer _ANNAPlayer;

        minproj = None;

        if(_ANNAPlayer(Player) == None)
        {
            SetTimer(0.1,False);
            return;
        }
        
        _ANNAPlayer = _ANNAPlayer(Player);

        if((Level.NetMode != NM_Standalone) && (Level.Timeseconds > defenseSoundTime))
        {
            _ANNAPlayer.PlaySound(Sound'AugDefenseOn', SLOT_Interact, 1.0, ,(LevelValues[CurrentLevel]*1.33), 0.75);
            defenseSoundTime = Level.Timeseconds + defenseSoundDelay;
        }

        minproj = FindNearestProjectile();

        if(minproj != None)
        {
            bDefenseActive = True;
            mindist = VSize(_ANNAPlayer.Location - minproj.Location);

            if(Level.Netmode != NM_Standalone)
                TriggerDefenseAugHUD();
            else
                SetDefenseAugStatus(True,CurrentLevel,minproj);

            _ANNAPlayer.PlaySound(sound'GEPGunLock', SLOT_None,,,, 2.0);

            if(mindist < LevelValues[CurrentLevel])
            {
                minproj.bAggressiveExploded = True;
                minproj.Explode(minproj.Location, vect(0,0,1));
                _ANNAPlayer.PlaySound(sound'ProdFire', SLOT_None,,,, 2.0);
                
                energyDrain = (_ANNAAugmentationManager(_ANNAPlayer.AugmentationSystem).GetEnergyUsage(class'ANNAAugDefense') / 3);
                _ANNAPlayer.EnergyDrain += energyDrain;
                _ANNAPlayer.EnergyDrainTotal += energyDrain;
            }
		}
        else
        {
            if((Level.NetMode == NM_Standalone) || (bDefenseActive))
                SetDefenseAugStatus(False, CurrentLevel, None);

            bDefenseActive = false;
        }
    }

Begin:
    SetTimer(0.1, True);
}

defaultproperties
{
}
