//=============================================================================
// ANNAAugNanobots.
//=============================================================================
class ANNAAugNanobots extends Augmentation;

var float mpAugValue;
var float mpEnergyDrain;

state Active
{
Begin:
Loop:
	Sleep(1.0);
    
    HealPlayers();

	Goto('Loop');
}

function HealPlayers()
{
    local Actor a;
    local _ANNAPlayer target, targetList[3];
    local int count, i, healamount, totalamount;

    count = 0;

    if(TeamDMGame(Player.DXGame) != None || 1 == 1) // Healing teammates in deathmatch is useless.
    {
        foreach RadiusActors(class'Actor', a, 256, Player.Location)
        {
            if(a.IsA('_ANNAPlayer')) // TODO: Only heal teammates
            {
                target = _ANNAPlayer(a);
                if(target.PlayerReplicationInfo != None && !target.PlayerReplicationInfo.bIsSpectator && target.Health > 0 && target.Health < 100 && (target.lastTeamHeal+1 <= Level.TimeSeconds))
                {
                    targetList[count] = target;
                    count++;
                    if(count == 3) // We heal a maximum of 3 players
                        break;
                }
            }
        }
        
        if(count > 0)
        {
            healamount = Min(10, (15/count));
            totalamount = healamount*count;
            for(i = 0; i < count; i++)
            {
                if(targetList[i] != None)
                {
                    targetList[i].HealPlayer(healamount, False);
                    targetList[i].ClientFlash(0.5, vect(0, 0, 500));
                    targetList[i].lastTeamHeal = Level.TimeSeconds;
                }
            }
            if(totalamount > 0)
            {
                Player.ClientMessage("Healed"@count@"nearby player(s) for"@totalamount$"HP");
            }
        }
    }
}

function Deactivate()
{
	Super.Deactivate();
}

function float GetEnergyRate()
{
	return energyRate * LevelValues[CurrentLevel];
}

simulated function PreBeginPlay()
{
	Super.PreBeginPlay();

	// If this is a netgame, then override defaults
	if ( Level.NetMode != NM_StandAlone )
	{
		LevelValues[3] = mpAugValue;
		EnergyRate = mpEnergyDrain;
        AugmentationLocation = LOC_Torso;
	}
}

defaultproperties
{
    mpAugValue=0.50
    mpEnergyDrain=30.00
    EnergyRate=300.00
    Icon=Texture'DeusExUI.UserInterface.AugIconRadarTrans'
    smallIcon=Texture'DeusExUI.UserInterface.AugIconRadarTrans_Small'
    AugmentationName="Nanobots"
    Description="Radar-absorbent resin augments epithelial proteins; microprojection units distort agent's visual signature. Provides highly effective concealment from automated detection systems -- bots, cameras, turrets.|n|nTECH ONE: Power drain is normal.|n|nTECH TWO: Power drain is reduced slightly.|n|nTECH THREE: Power drain is reduced moderately.|n|nTECH FOUR: Power drain is reduced significantly."
    MPInfo="When active, you are invisible to electronic devices such as cameras, turrets, and proximity mines.  Energy Drain: Very Low"
    LevelValues(0)=1.00
    LevelValues(1)=0.83
    LevelValues(2)=0.66
    LevelValues(3)=0.50
    AugmentationLocation=5
    MPConflictSlot=2
}
