//=============================================================================
// _ANNAMenuScreenAugSetup
//=============================================================================
class ANNAMenuScreenAugSetup expands CBPMenuScreenAugSetup;

var MenuUIScrollAreaWindow PresetScroll;
var MenuUIListWindow PresetList;
var MenuUIChoiceButton btnPresetLoad;

event InitWindow()
{
    Super.InitWindow();
    CreatePresetList();
    PopulatePresetList();
}

function CreatePresetList()
{
    CreateMenuLabel(551, 12, "Presets", winClient);
    PresetScroll = CreateScrollAreaWindow(winClient);

	PresetScroll.SetPos(560, 29);
	PresetScroll.SetSize(60, 152);

	PresetList = MenuUIListWindow(PresetScroll.clipWindow.NewChild(Class'MenuUIListWindow'));
	PresetList.EnableMultiSelect(False);
	PresetList.EnableAutoExpandColumns(False);
	PresetList.EnableHotKeys(False);

	PresetList.SetNumColumns(1);

	PresetList.SetColumnWidth(0, 140);
	PresetList.SetColumnType(0, COLTYPE_String);

    PresetList.SetFocusRow(0);
    PresetList.SelectAllRows(False);
    
    btnPresetLoad = MenuUIChoiceButton(winClient.NewChild(Class'MenuUIChoiceButton'));
    btnPresetLoad.SetButtonText("Load");
    btnPresetLoad.SetPos(551, 190);
    btnPresetLoad.SetWidth(50);
    btnPresetLoad.fontButtonText = font'FontMenuSmall';
}

function PopulatePresetList()
{
    local int i;
    local string presetName;

    while(true)
    {
        presetName = Class'ANNAAugConfig'.GetConfig("ANNA.AugPresets", "Preset["$i$"][Name]");
        if(len(presetName) != 0)
            PresetList.AddRow(presetName, i);
        else
            break;

        i++;
    }
}

function bool ButtonActivated(Window buttonPressed)
{
    local bool bHandled;

    bHandled = True;

    switch(buttonPressed)
    {
        case btnPresetLoad:
            LoadPreset();
        break;

        default:
            bHandled = False;
        break;
    }

    if(!bHandled)
        bHandled = Super.ButtonActivated(buttonPressed);

    return bHandled;
}

function LoadPreset()
{
    local int presetID, AugIndex;
    local string presetName, augName;
    
    presetID = PresetList.GetRowClientInt(PresetList.GetSelectedRow());
    
    presetName = Class'ANNAAugConfig'.GetConfig("ANNA.AugPresets", "Preset["$presetID$"][Name]");
    if(len(presetName) != 0)
    {
        for(AugIndex = 0; AugIndex < ArrayCount(ChosenAugs); AugIndex++)
        {
            ChosenAugs[AugIndex] = "";
            augName = Class'ANNAAugConfig'.GetConfig("ANNA.AugPresets", "Preset["$presetID$"][AugPrefs]["$AugIndex$"]");
            if(len(augName) != 0)
            {
                ChosenAugs[AugIndex] = augName;
                if(ChosenAugs[AugIndex] == "None")
                    ChosenAugs[AugIndex] = "";
            }
        }

        CompressChosenList();
        PopulateChosenList();
        EnableButtons();
    }
}

defaultproperties
{
    ClientWidth=620
}
