//================================================================================
// _ANNAMenuMain. (C) 2012 "Dei" & Nobody
//================================================================================
class _ANNAMenuMain extends MTLMenuMain;

function ShowVersionInfo()
{
    local TextWindow version;

    version = TextWindow(NewChild(Class'TextWindow'));
    version.SetLines(1, 3);
    version.SetTextMargins(0, 0);
    version.SetWindowAlignments(HALIGN_Right, VALIGN_Bottom);
    version.SetTextColorRGB(255, 255, 255);
    version.SetTextAlignments(HALIGN_Right, VALIGN_Bottom);
    version.SetText(Player.GetDeusExVersion() $ "|nSep 02 2002 DXMTL V1.52b1" $ "|nAug 05 2013 ANNA V1.03");
}

function UpdateButtonStatus()
{
    local DeusExLevelInfo info;

    info = Player.GetLevelInfo();

    if(((info != None) && (info.MissionNumber < 0)) || ((Player.IsInState('Dying')) || (Player.IsInState('Paralyzed')) || (Player.IsInState('Interpolating'))))
    {
        if(Player.Level.NetMode == NM_Standalone)
        {
            winButtons[1].SetSensitivity(False);
            winButtons[7].SetSensitivity(False);
        }
    }

    // Disable the "Save Game", "New Game", "Training" and "Load Game" menu choices if in multiplayer
    if(Player.Level.Netmode != NM_Standalone)
    {
        winButtons[0].SetSensitivity(False);
        winButtons[1].SetSensitivity(False);
        winButtons[2].SetSensitivity(False);
        winButtons[4].SetSensitivity(False);
        if(_ANNAPlayer(Player) != None && !_ANNAPlayer(Player).bSpectatingEnabled)
            winButtons[6].SetSensitivity(False);
    }
    else
        winButtons[6].SetSensitivity(False); // Spectating in singleplayer? No thanks..

    if(Player.dataLinkPlay != None)
        winButtons[1].SetSensitivity(False);
}

function ProcessCustomMenuButton(string key)
{
    if(key == "playerSpectate" && _ANNAPlayer(Player) != None)
    {
        _ANNAPlayer(Player).Spectate();
        root.PopWindow();
    }
}

function CreateMenuButtons()
{
    if(Player.PlayerReplicationInfo.bIsSpectator)
        ButtonNames[6]="Join Game";

    Super.CreateMenuButtons();
}

defaultproperties
{
    ButtonNames(5)="Credits"
    ButtonNames(6)="Spectate"
    buttonDefaults(5)=(Y=193,Action=MA_MenuScreen,Invoke=Class'CreditsWindow',Key="")
    buttonDefaults(6)=(Y=229,Action=MA_Custom,Invoke=None,Key="playerSpectate")
    buttonDefaults(8)=(Y=301,Action=MA_MenuScreen,Invoke=Class'ANNAMenuMPMain',Key="")
    ClientHeight=430
}