//================================================================================
// EMMAManager. (C) 2012 "Dei" & Nobody
//================================================================================
class EMMAManager extends Actor;

var private EMMAModule BaseModule;

const BOOL_FALSE = 0;
const BOOL_TRUE = 1;

// PostPostBeginPlay is called twice... so we add the function data to Timer()!
function PostPostBeginPlay()
{
    SetTimer(1.0, False);

    Super.PostPostBeginPlay();
}

function Timer()
{
    local int bModulesLoaded;

    Log("Modules:", 'EMMA');
    
    if(BaseModule != None)
        BaseModule.IdentifyModule(bModulesLoaded);
    
    if(bModulesLoaded != BOOL_TRUE)
        Log("No modules have been loaded."@self, 'EMMA');
}

final function AddModule(EMMAModule M)
{
    assert(Class == class'EMMAManager');

    if(BaseModule == None)
        BaseModule = M;
    else
        BaseModule.AddModule(M);
}

final function ScoreKill(pawn Killer, pawn Other)
{
    if(BaseModule != None)
        BaseModule.callScoreKill(Killer, Other);
}

final function Logout(pawn Exiting)
{
    if(BaseModule != None)
        BaseModule.callLogout(Exiting);
}

final function PlayerDestroyed(DeusExPlayer Player)
{
    if(BaseModule != None)
        BaseModule.callPlayerDestroyed(Player);
}

final function NavigationPoint FindPlayerStart(Pawn Player, optional byte InTeam, optional string incomingName)
{
    if(BaseModule != None)
        return BaseModule.callFindPlayerStart(Player, InTeam, incomingName);

    return None;
}

final function PreLogin(string Options, string Address, out string Error, out string FailCode, out int bOverride)
{
    if(BaseModule != None)
        BaseModule.callPreLogin(Options, Address, Error, FailCode, bOverride);
}

final function string ScoreBoard()
{
    if(BaseModule != None)
        return BaseModule.ScoreBoard();

    return "";
}

final function string MenuMain()
{
    if(BaseModule != None)
        return BaseModule.MenuMain();

    return "";
}

final function string GameName()
{
    if(BaseModule != None)
        return BaseModule.GameName();

    return "";
}

final function HandleDeathNotification(Pawn killer, Pawn killee, out int bOverride)
{
    if(BaseModule != None)
        BaseModule.callHandleDeathNotification(killer, killee, bOverride);
}

final function Killed(pawn Killer, pawn Other, name damageType, out int bOverride)
{
    if(BaseModule != None)
        BaseModule.callKilled(killer, Other, damageType, bOverride);
}

final function bool CheckVictoryConditions(Pawn Killer, Pawn Killee, String Method, out int bOverride)
{
    if(BaseModule != None)
        return BaseModule.callCheckVictoryConditions(Killer, Killee, Method, bOverride);

    return false;
}

final function ChangeTeam(Pawn PawnToChange, out int NewTeam, out int bOverride)
{
    if(BaseModule != None)
        BaseModule.callChangeTeam(PawnToChange, NewTeam, bOverride);
}

final function GiveInitialInventory(DeusExPlayer Player, out int bOverride)
{
    if(BaseModule != None)
        BaseModule.callGiveInitialInventory(Player, bOverride);
}

final function PlayerPossess(DeusExPlayer Player)
{
    if(BaseModule != None)
        BaseModule.callPlayerPossess(Player);
}

final function SetName(DeusExPlayer Player, string NewName, out int bOverride)
{
    if(BaseModule != None)
        BaseModule.callSetName(Player, NewName, bOverride);
}

final function PlayerCommand(DeusExPlayer Player, string Command, out int bOverride)
{
    if(BaseModule != None)
        BaseModule.callPlayerCommand(Player, Command, bOverride);
}

final function DropItem(DeusExPlayer Player, Inventory Item, out int bOverride)
{
    if(BaseModule != None)
        BaseModule.callDropItem(Player, Item, bOverride);
}

defaultproperties
{
    bHidden=true
}